import java.util.*;
import com.nttdocomo.ui.*;

/**
 *	sN`NXB
 *		SsN`ʂ̊NXB
 */
public abstract class Picture {

	/** sN`̕ */
	public static final int WIDTH  = 128;
	/** sN`̍ */
	public static final int HEIGHT = 128;

	/*
	 *	sN`̎ނ萔
	 */
	/** sN`̎(^Cg) */
	public static final int TYPE_TITLE = 0;
	/** sN`̎(ubN) */
	public static final int TYPE_BREAK_OUT = 1;
	/** sN`̎(oEX{[) */
	public static final int TYPE_BOUNCE_BALLS = 2;
	/** sN`̎(tCO{[h) */
	public static final int TYPE_THE_FLYING_BOARDS = 3;
	/** sN`̎(CA[g) */
	public static final int TYPE_LINE_ART = 4;
	/** sN`̎(df) */
	public static final int TYPE_AN_ELECTRONIC_BOARD = 5;
	/** sN`̎(g) */
	public static final int TYPE_RIPPLES = 6;
	/** sN`̎(CtQ[) */
	public static final int TYPE_THE_GAME_OF_LIFE = 7;

	/** sN`̎ނ̐ */
	public static final int TYPE_NUM = 8;

	protected Graphics graphics = null;
	private static Random random = new Random();
	private Image image = null;

	protected int counter = 0;
	private int type = 0;

	public Picture() {}

	public void finalize() {
		quit();
	}

	/**
	 *	sN`IuWFNg𐶐B
	 *	@param	type	sN`̎(TYPE_BREAK_OUTȂ)
	 */
	public static Picture getInstance(int type) {
		final Picture picture;

		switch (type) {
		case TYPE_TITLE:
			picture = new PictureTitle();
			break;
		case TYPE_BREAK_OUT:
			picture = new PictureBreakOut();
			break;
		case TYPE_BOUNCE_BALLS:
			picture = new PictureBounceBalls();
			break;
		case TYPE_THE_FLYING_BOARDS:
			picture = new PictureTheFlyingBoards();
			break;
		case TYPE_LINE_ART:
			picture = new PictureLineArt();
			break;
		case TYPE_AN_ELECTRONIC_BOARD:
			picture = new PictureAnElectronicBoard();
			break;
		case TYPE_RIPPLES:
			picture = new PictureRipples();
			break;
		case TYPE_THE_GAME_OF_LIFE:
			picture = new PictureTheGameOfLife();
			break;
		default:
			picture = null;
			break;
		}

		if (picture != null) {
			picture.type = type;
		}

		return picture;
	}

	/**
	 *	SsN`IuWFNgʂ̏sB
	 */
	public void init() {
		quit();

		image = Image.createImage(WIDTH, HEIGHT);
		graphics = image.getGraphics();
		counter = 0;

		initImp();
	}

	/**
	 *	SsN`IuWFNgʂ̏IsB
	 */
	public void quit() {

		quitImp();

		counter = 0;
		if (graphics != null) {
			graphics = null;
		}
		if (image != null) {
			image.dispose();
			image = null;
		}
	}

	/**
	 *	SsN`IuWFNgʂ̃sN`XV̏sB
	 */
	public void update() {
		updateImp();
		counter++;
	}

	public Image getImage() {return image;}
	public int getType() {return type;}

	/** esN`IuWFNgŗL̏sB */
	protected abstract void initImp();
	/** esN`IuWFNgŗL̏IsB */
	protected abstract void quitImp();
	/** esN`IuWFNgŗL̃sN`XVsB */
	protected abstract void updateImp();

	protected static int getRandom(int max) {return (random.nextInt() >>> 1) % max;}

	/**
	 *	sN`̖O擾B
	 *	@return	sN`̖O
	 */
	public String getName() {
		return getPictureName(type);
	}

	/**
	 *	sN`̖O擾B
	 *	@param	type	sN`̎(TYPE_BREAK_OUTȂ)
	 *	@return	sN`̖O
	 */
	public static String getPictureName(int type) {
		final String name;

		switch (type) {
		case TYPE_TITLE:
			name = PictureTitle.getPictureName();
			break;
		case TYPE_BREAK_OUT:
			name = PictureBreakOut.getPictureName();
			break;
		case TYPE_BOUNCE_BALLS:
			name = PictureBounceBalls.getPictureName();
			break;
		case TYPE_THE_FLYING_BOARDS:
			name = PictureTheFlyingBoards.getPictureName();
			break;
		case TYPE_LINE_ART:
			name = PictureLineArt.getPictureName();
			break;
		case TYPE_AN_ELECTRONIC_BOARD:
			name = PictureAnElectronicBoard.getPictureName();
			break;
		case TYPE_RIPPLES:
			name = PictureRipples.getPictureName();
			break;
		case TYPE_THE_GAME_OF_LIFE:
			name = PictureTheGameOfLife.getPictureName();
			break;
		default:
			name = "";
			break;
		}

		return name;
	}
}
