import com.nttdocomo.ui.*;

public class PictureLineArt extends Picture {

	private static final int NUM_LINE = 4;
	private static final int NUM_SHADOW = 4;

	private static final int rgbBackground = Graphics.getColorOfRGB(0, 0, 0);

	private int[][] pxVertexesX = new int[NUM_LINE][NUM_SHADOW];
	private int[][] pxVertexesY = new int[NUM_LINE][NUM_SHADOW];
	private int[] pxVertexesVX = new int[NUM_LINE];
	private int[] pxVertexesVY = new int[NUM_LINE];

	protected void initImp() {
		for (int i = 0; i < NUM_LINE; i++) {
			final int pxTmpX = getRandom(WIDTH);
			final int pxTmpY = getRandom(HEIGHT);
			for (int j = 0; j < NUM_SHADOW; j++) {
				pxVertexesX[i][j] = pxTmpX;
				pxVertexesY[i][j] = pxTmpY;
			}

			pxVertexesVX[i] = getRandom(15) - 7;
			pxVertexesVY[i] = getRandom(15) - 7;
		}

		graphics.setColor(rgbBackground);
		graphics.fillRect(0, 0, WIDTH, HEIGHT);
	}

	protected void quitImp() {}

	protected void updateImp() {
		for (int i = 0; i < NUM_LINE; i++) {
			for (int j = NUM_SHADOW - 1; j >= 1; j--) {
				pxVertexesX[i][j] = pxVertexesX[i][j - 1];
				pxVertexesY[i][j] = pxVertexesY[i][j - 1];
			}
		}

		for (int i = 0; i < NUM_LINE; i++) {
			pxVertexesX[i][0] += pxVertexesVX[i];
			pxVertexesY[i][0] += pxVertexesVY[i];

			if (pxVertexesX[i][0] <= 0) {
				pxVertexesX[i][0] = 0;
				pxVertexesVX[i] = getRandom(7) + 1;
			} else if (pxVertexesX[i][0] >= WIDTH - 1) {
				pxVertexesX[i][0] = WIDTH - 1;
				pxVertexesVX[i] = -(getRandom(7) + 1);
			}

			if (pxVertexesY[i][0] <= 0) {
				pxVertexesY[i][0] = 0;
				pxVertexesVY[i] = getRandom(7) + 1;
			} else if (pxVertexesY[i][0] >= HEIGHT - 1) {
				pxVertexesY[i][0] = HEIGHT - 1;
				pxVertexesVY[i] = -(getRandom(7) + 1);
			}
		}

		graphics.setColor(rgbBackground);
		graphics.fillRect(0, 0, WIDTH, HEIGHT);

		final int tmpRed   = 160 + (((((counter / 77) % 8) & 0x01) != 0) ? 64 : 0) + (counter +  0) % 32;
		final int tmpGreen = 160 + (((((counter / 77) % 8) & 0x02) != 0) ? 64 : 0) + (counter + 11) % 32;
		final int tmpBlue  = 160 + (((((counter / 77) % 8) & 0x04) != 0) ? 64 : 0) + (counter + 21) % 32;
		for (int i = NUM_SHADOW - 1; i >= 0; i--) {
			graphics.setColor(Graphics.getColorOfRGB(tmpRed * (i + 4) / 8, tmpGreen * (i + 4) / 8, tmpBlue * (i + 4) / 8));
			graphics.drawLine(pxVertexesX[0][i], pxVertexesY[0][i], pxVertexesX[1][i], pxVertexesY[1][i]);
			graphics.drawLine(pxVertexesX[1][i], pxVertexesY[1][i], pxVertexesX[2][i], pxVertexesY[2][i]);
			graphics.drawLine(pxVertexesX[2][i], pxVertexesY[2][i], pxVertexesX[3][i], pxVertexesY[3][i]);
			graphics.drawLine(pxVertexesX[3][i], pxVertexesY[3][i], pxVertexesX[0][i], pxVertexesY[0][i]);
		}
	}

	public static String getPictureName() {
		return "Line Art";
	}
}
