import com.nttdocomo.ui.*;

/**
 *	XN[`NXB
 */
public class Screen {

	/*
	 *	ʗ̈̎ނ萔
	 */
	/** ʒ */
	public static final int POS_CENTER = 0;
	/** ʏ */
	public static final int POS_TOP    = 1;
	/** ʉ */
	public static final int POS_BOTTOM = 2;
	/** ʍ */
	public static final int POS_LEFT   = 3;
	/** ʉE */
	public static final int POS_RIGHT  = 4;

	/*
	 *	J[\̎ނ萔
	 */
	/**  */
	public static final int CURSOR_TYPE_CURRENT  = 0;
	/**  */
	public static final int CURSOR_TYPE_SELECTED = 1;

	/** ʂ̕ */
	private static final int PX_SCREEN_WIDTH  = 240;
	/** ʂ̍ */
	private static final int PX_SCREEN_HEIGHT = 240;

	/** s[X̕ */
	private static final int PX_PIECE_WIDTH  = 32;
	/** s[X̍ */
	private static final int PX_PIECE_HEIGHT = 32;

	/** es[Ẍʒu(XW) */
	private static final int[] pxPieceX = {
		 56,  88, 120, 152,
		 56,  88, 120, 152,
		 56,  88, 120, 152,
		 56,  88, 120, 152,

		 44,  84, 124, 164,
		 44,  84, 124, 164,
		  8,   8,   8,   8,
		200, 200, 200, 200,
	};
	/** es[Ẍʒu(YW) */
	private static final int[] pxPieceY = {
		 48,  48,  48,  48,
		 80,  80,  80,  80,
		112, 112, 112, 112,
		144, 144, 144, 144,

		  8,   8,   8,   8,
		184, 184, 184, 184,
		 42,  78, 114, 150,
		 42,  78, 114, 150,
	};

	/** ptHg */
	private static final Font fontStrong = Font.getFont(Font.SIZE_SMALL);
	/** ʏtHg */
	private static final Font fontNormal = Font.getFont(Font.SIZE_TINY);

	/** EBhËʒu(XW) */
	private static final int pxInfoWindowX = 8;
	/** EBhËʒu(YW) */
	private static final int pxInfoWindowWidth  = PX_SCREEN_WIDTH - pxInfoWindowX * 2;
	/** EBhE̕ */
	private static final int pxInfoWindowHeight = 2 + fontNormal.getHeight() + 2;
	/** EBhE̍ */
	private static final int pxInfoWindowY = PX_SCREEN_HEIGHT - 2 - pxInfoWindowHeight;

	/** `ΏۂƂOtBbNXIuWFNg */
	private Graphics graphics = null;

	/**
	 *	XN[IuWFNg𐶐B
	 *	@param	canvas	`ΏۂƂLoX
	 */
	public Screen(Canvas canvas) {
		// `ΏۂƂȂOtBbNXIuWFNg擾
		graphics = canvas.getGraphics();
	}

	/**
	 *	_uobt@OJnB
	 *	@see	com.nttdocomo.ui.Graphics#lock
	 */
	public void lockGrp() {
		graphics.lock();
	}

	/**
	 *	_uobt@OIB
	 *	@param	forced	IɃtbV邩ǂ
	 *	@see	com.nttdocomo.ui.Graphics#unlock
	 */
	public void unlockGrp(boolean forced) {
		graphics.unlock(forced);
	}

	/**
	 *	wi`悷B
	 */
	public void drawBackground() {

		// ʑŜ̕`s
		for (int i = 0; i < 8; i++) {
			graphics.setColor(Graphics.getColorOfRGB(128 + i * 8, 128 + i * 8, 128 + i * 8));
			graphics.fillRect(0, i * 4, PX_SCREEN_WIDTH, 64 - i * 8);
		}
		for (int i = 0; i < 12; i++) {
			graphics.setColor(Graphics.getColorOfRGB(128 + i * 8, 128 + i * 8, 128 + i * 8));
			graphics.fillRect(0, 64 + i * 4, PX_SCREEN_WIDTH, PX_SCREEN_HEIGHT - 64 - i * 8);
		}

		// ̃sN`̘g`悷
		graphics.setColor(Graphics.getColorOfRGB(96, 96, 96));
		graphics.drawRect(pxPieceX[0] - 1, pxPieceY[0] - 1, Picture.WIDTH, Picture.HEIGHT);
		graphics.setColor(Graphics.getColorOfRGB(255, 255, 255));
		graphics.drawRect(pxPieceX[0], pxPieceY[0], Picture.WIDTH, Picture.HEIGHT);

		// ӂ̃s[X̘g`悷
		for (int i = 16; i < pxPieceX.length; i++) {
			graphics.setColor(Graphics.getColorOfRGB(96, 96, 96));
			graphics.drawRect(pxPieceX[i] - 1, pxPieceY[i] - 1, PX_PIECE_WIDTH, PX_PIECE_HEIGHT);
			graphics.setColor(Graphics.getColorOfRGB(255, 255, 255));
			graphics.drawRect(pxPieceX[i], pxPieceY[i], PX_PIECE_WIDTH, PX_PIECE_HEIGHT);
		}
	}

	/**
	 *	Ss[X̕`sB
	 *	@param	picture		sN`
	 *	@param	posInfo		s[Ẍʒu
	 */
	public void drawPieces(Image picture, int[] posInfo) {
		for (int i = 0; i < posInfo.length; i++) {
			if (posInfo[i] >= 0) {
				drawPiece(picture, posInfo[i], i);
			}
		}
	}

	/**
	 *	Cʂ̑Ss[XES󗓂̕`sB
	 *	@param	picture		sN`
	 *	@param	posInfo		s[Ẍʒu
	 */
	public void drawMain(Image picture, int[] posInfo) {
		for (int i = 0; i < 16; i++) {
			if (posInfo[i] >= 0) {
				drawPiece(picture, posInfo[i], i);
			} else {
				drawBlank(i);
			}
		}
	}

	/**
	 *	S󗓂̕`sB
	 *	@param	posInfo		s[Ẍʒu
	 */
	public void drawBlanks(int[] posInfo) {
		for (int i = 0; i < posInfo.length; i++) {
			if (posInfo[i] < 0) {
				drawBlank(i);
			}
		}
	}

	/**
	 *	s[X`悷B
	 *	@param	pos		󗓂̈ʒu
	 */
	public void drawPiece(Image picture, int type, int pos) {
		graphics.drawImage(picture, pxPieceX[pos], pxPieceY[pos], PX_PIECE_WIDTH * (type % 4), PX_PIECE_HEIGHT * (type / 4), PX_PIECE_WIDTH, PX_PIECE_HEIGHT);
	}

	/**
	 *	󗓂`悷B
	 *	@param	pos		󗓂̈ʒu
	 */
	public void drawBlank(int pos) {
		graphics.setColor(Graphics.getColorOfRGB(192, 192, 192));
		graphics.drawRect(pxPieceX[pos], pxPieceY[pos], PX_PIECE_WIDTH - 1, PX_PIECE_HEIGHT - 1);
		graphics.setColor(Graphics.getColorOfRGB(128, 128, 128));
		graphics.drawRect(pxPieceX[pos], pxPieceY[pos], PX_PIECE_WIDTH - 2, PX_PIECE_HEIGHT - 2);
		graphics.setColor(Graphics.getColorOfRGB(160, 160, 160));
		graphics.fillRect(pxPieceX[pos] + 1, pxPieceY[pos] + 1, PX_PIECE_WIDTH - 2, PX_PIECE_HEIGHT - 2);
	}

	/**
	 *	J[\`悷B
	 *	@param	board	ՖʃIuWFNg
	 *	@param	pos		`悷J[\̈ʒu
	 *	@param	type	`悷J[\̎
	 */
	public void drawCursor(int pos, int type) {
		if (pos < 0) {
			return;
		}

		final int pxX = pxPieceX[pos];
		final int pxY = pxPieceY[pos];

		graphics.setColor(rgbCursor[type][counterCursor[type] % rgbCursor[type].length]);
		graphics.drawRect(pxX,     pxY,     PX_PIECE_WIDTH - 1, PX_PIECE_HEIGHT - 1);
		graphics.drawRect(pxX + 1, pxY + 1, PX_PIECE_WIDTH - 3, PX_PIECE_HEIGHT - 3);

		counterCursor[type]++;
	}
	private static final int[][] rgbCursor = {
		{
			Graphics.getColorOfRGB(255, 128, 128),
			Graphics.getColorOfRGB(192, 192, 128),
			Graphics.getColorOfRGB(128, 255, 128),
			Graphics.getColorOfRGB(128, 192, 192),
			Graphics.getColorOfRGB(128, 128, 255),
			Graphics.getColorOfRGB(192, 128, 192),
		},
		{
			Graphics.getColorOfRGB(255, 255, 255),
			Graphics.getColorOfRGB(128, 128, 128),
		},
	};
	private int[] counterCursor = {0, 0};

	/**
	 *	x`悷B
	 *	@param	string	x
	 *	@param	area	`悷ʒu
	 */
	public void drawLabelString(String string, int area) {

		// x`̊ʒu肷
		final int indexTopLeft;
		final int indexBottomRight;
		switch (area) {
		default:
		case POS_CENTER:
			indexTopLeft = 0;
			indexBottomRight = 15;
			break;
		case POS_TOP:
			indexTopLeft = 16;
			indexBottomRight = 19;
			break;
		case POS_BOTTOM:
			indexTopLeft = 20;
			indexBottomRight = 23;
			break;
		case POS_LEFT:
			indexTopLeft = 24;
			indexBottomRight = 27;
			break;
		case POS_RIGHT:
			indexTopLeft = 28;
			indexBottomRight = 31;
			break;
		}

		// x̕\ʒuZo
		final int pxWidth  = 4 + fontStrong.stringWidth(string) + 4;
		final int pxHeight = 2 + fontStrong.getHeight()         + 2;
		final int pxX = pxPieceX[indexTopLeft] + ((pxPieceX[indexBottomRight] - pxPieceX[indexTopLeft] + PX_PIECE_WIDTH)  - pxWidth)  / 2;
		final int pxY = pxPieceY[indexTopLeft] + ((pxPieceY[indexBottomRight] - pxPieceY[indexTopLeft] + PX_PIECE_HEIGHT) - pxHeight) / 2;

		// x\g`悷
		graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));
		graphics.drawRect(pxX + 1, pxY + 1, pxWidth - 1, pxHeight - 1);
		graphics.setColor(Graphics.getColorOfRGB(255, 255, 255));
		graphics.drawRect(pxX, pxY, pxWidth - 1, pxHeight - 1);
		graphics.setColor(Graphics.getColorOfRGB(96, 96, 96));
		graphics.fillRect(pxX + 2, pxY + 2, pxWidth - 3, pxHeight - 3);

		// x`悷
		graphics.setFont(fontStrong);
		graphics.setColor(Graphics.getColorOfRGB(255, 255, 255));
		graphics.drawString(string, pxX + 4, pxY + 2 + fontStrong.getAscent());
	}

	/**
	 *	񕶎`悷B
	 *	@param	string	񕶎
	 */
	public void drawInfoString(String string) {

		// 񕶎\g`悷
		graphics.setColor(Graphics.getColorOfRGB(96, 96, 96));
		graphics.drawRect(pxInfoWindowX, pxInfoWindowY, pxInfoWindowWidth - 1, pxInfoWindowHeight - 1);
		graphics.setColor(Graphics.getColorOfRGB(255, 255, 255));
		graphics.drawRect(pxInfoWindowX, pxInfoWindowY, pxInfoWindowWidth - 2, pxInfoWindowHeight - 2);
		graphics.setColor(Graphics.getColorOfRGB(192, 192, 192));
		graphics.fillRect(pxInfoWindowX + 1, pxInfoWindowY + 1, pxInfoWindowWidth - 2, pxInfoWindowHeight - 2);

		// 񕶎`悷
		graphics.setFont(fontNormal);
		graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));
		graphics.drawString(string, pxInfoWindowX + 2, pxInfoWindowY + fontNormal.getHeight());
	}

	/**
	 *	oߎԂ`悷B
	 *	@param	time	oߎ(P: msec)
	 */
	public void drawTime(int time) {

		// oߎԂ\쐬
		StringBuffer sbTime = new StringBuffer();
		sbTime.append((time / 600000) % 10)
			.append((time / 60000) % 10)
			.append(":")
			.append((time / 10000) % 6)
			.append((time / 1000) % 10);

		// oߎԕ\ʒu肷(񕶎\g̉E[)
		final int pxWidth = fontNormal.stringWidth(sbTime.toString());
		final int pxX = PX_SCREEN_WIDTH - pxInfoWindowX - pxWidth;

		// 񕶎\g̉n`悷
		graphics.setColor(Graphics.getColorOfRGB(192, 192, 192));
		graphics.fillRect(pxX + 1, pxInfoWindowY + 1, pxWidth - 2, pxInfoWindowHeight - 2);

		// oߎԕ`悷
		graphics.setFont(fontNormal);
		graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));
		graphics.drawString(sbTime.toString(), pxX, pxInfoWindowY + fontNormal.getHeight());
	}
}
